module kinds
! From Ignacy Misztal BLUPF90 distribution 
  integer, parameter :: single = SELECTED_REAL_KIND( 6, 37 )
  integer, parameter :: double = SELECTED_REAL_KIND( 15, 307 )
  integer, parameter :: extended = SELECTED_REAL_KIND( 18, 4931 )
  integer, parameter :: r4 = SELECTED_REAL_KIND( 6, 37 )
  integer, parameter :: r8 = SELECTED_REAL_KIND( 15, 307 )
  integer, parameter :: r16 = SELECTED_REAL_KIND( 18, 4931 )

  ! current precison for hash storage
  integer, parameter :: rh=r8
end module kinds

      !---------------------------------------------
      module varcovar
      use kinds
      contains
      function var(x) result(resul)

      implicit none
      real(r8),dimension(:),intent(in) :: x
      real(r8) :: resul

      resul=(sum(x*x)-(sum(x)**2)/size(x))/(size(x)-1)

      end function var
      !---------------------------------------------

      function cov (x,y) result(resul)

      implicit none
      real(r8),dimension(:),intent(in) :: x,y
      real(r8) :: resul

      if (size(x).ne.size(y)) then
       print *,'Matrices x e y no concuerdan ',size(x),size(y)
      stop
      endif

      resul=(sum(x*y)-(sum(x)*sum(y))/size(x))/(size(x)-1)

      end function cov
      end module varcovar



! program to simulate bivariate model

        program simul
	use kinds; use varcovar
        implicit double precision (a-h,o-z)
	
!          interface ! PARA LAS FUNCIONES DE VARIANZA Y COVARIANZA
!        function varianza(x) result(resul)
!        use kinds
!        real(r8),dimension(:),intent(in) :: x
!        real(r8) :: resul

!        end function varianza
!        function covarianza (x,y) result(resul)
!        use kinds
!         real(r8),dimension(:),intent(in) :: x,y
!         real(r8) :: resul!

!          end function covarianza
!        end interface

        integer :: nanim
        integer :: nsire
        integer :: ndam,herds
        real(r8) ,allocatable:: vg(:,:)
        real(r8)  vara(2,2)
        real(r8) vare(2,2)
        real(r8) zero(2),b(2),y(2)
	real(r8) mean(2),covariate,beta
	character(1)rec
	
	x1=948.d0
	print *,'seed?'
        read*,x1
	print*,'how many sires?'
	read*,nsire
	print*,'how many dams?'
	read*,ndam
	print*,'how many animals?'
	read*,nanim
	print*,'how many herds?'
	read*,herds
	print *,'3rd fixed effect has ',herds,' levels'


	allocate (vg(nanim,2) )
	
          vare=reshape( (/20.d0,     7.d0, &
	                     7.d0,50.d0/),(/2,2/) )
	  vara=reshape( (/81.d0, -55.d0, &
	                 -55.d0,150.d0/),(/2,2/) )
	  
	  mean=reshape( (/10.d0,100.d0/),(/2/) )
	  covariate=1d0

	
	mean(1)=mean(1) !to correct at environmental level
		
        zero=0.d0
        vg=0.d0

        open(11,file='geneakk',status='replace')
        open(13,file='geneakksire',status='replace')
        open(12,file='datoskk',status='replace')
        open(14,file='datoskksire',status='replace')
	open(15,file='geneaf90',status='replace')
!       sire sampling
        do i=1,nsire
          call mvn(zero,vara,b,2,x1)
          vg(i,:)=b
!          print *,b
!          write(11,'(3i10)')i,0,0
          write(13,'(3i10)')i,0,0
          write(11,'(3i10)')i,nanim+1,nanim+1
	  write(15,'(3i10)')i,0,0
        enddo

!       dam sampling

        do i=nsire+1,nsire+ndam
          call mvn(zero,vara,b,2,x1)
          vg(i,:)=b
!          write(11,'(3i10)')i,0,0
          write(11,'(3i10)')i,nanim+1,nanim+1
	  write(15,'(3i10)')i,0,0
        enddo

!       offspring sampling

        do i=nsire+ndam+1,nanim
           call unif(x1,u)
           ip=int(u*nsire)+1
           call unif(x1,u)
           im=int(u*ndam)+nsire+1
           vg(i,:)=0.5*vg(ip,:)+0.5*vg(im,:)
	   !mendelian sampling
           call mvn(zero,vara/2.,b,2,x1)
           vg(i,:)=vg(i,:)+b
           write(11,'(3i10)')i,ip,im
           write(15,'(3i10)')i,ip,im
!       record sampling
           call mvn(zero,vare,b,2,x1)
!       covariate sampling
           call unif(x1,u)	   
	   beta=u
	   
           y=vg(i,:)+b+mean
	   y(1)=y(1)+beta*covariate

          call unif(x1,u)
          if1=int(u*10.)+1 !1st fixed effect
          call unif(x1,u)
          if2=int(u*20.)+1 !2nd f.e.
          call unif(x1,u)  
          if3=int(u*herds)+1 !etc..
          call unif(x1,u)
          if4=int(10.*u)+1
	  
! liability: 2nd trait above or below the mean
          if(y(2)<(mean(2))) then
	    y(2)=1
	  else
	    y(2)=2   
	  endif	  
	  !censoring
!          call unif(x1,u)
!	  if ( (u<.25) ) y(1)=-2

          !if(mod(i,100)==0) print *,i
	  !fixed effects animal trait 1 &  2 
          write(12,*)beta,if1,if2,if3,if4,i,y
! with sire model
          write(14,*)beta,if1,if2,if3,if4,ip,y
        enddo
	print *,cov(vg(:,1),vg(:,2))/sqrt( var(vg(:,1))*var(vg(:,2)))
	close(11)
	close(12)

        end



! ----------------------------------------------------------------------
      subroutine normal(x1,z)
!      generacion de un numero normal z -> n(0,1)
!      x1 es la semilla
      use kinds
      implicit double precision(a-h,o-z)
      real(r8) :: x1,z,u1,u2
      call unif(x1,u1)
      call unif(x1,u2)
      z=((-2.*log(u1))**0.5)*cos(2.*3.1416*u2)
      return
      end
! ----------------------------------------------------------------------
! ----------------------------------------------------------------------
      subroutine unif(x1,u)
!      generacion de un numero uniforme u[0,1]
!      x1 es la semilla
      implicit double precision(a-h,o-z)
      divis=2.**31.-1.
      trans=7.**5.
      divid=trans*x1
      lsol=int(divid/divis)
      x1=divid-lsol*divis
      u=x1/divis
      return
      end
! ----------------------------------------------------------------------
! ------------------------------
      subroutine mvn(a,v,b,n,x1)
! Genera normales multivariadas b~MVN(a,v) de rango n con semilla x1
! A partir de una subrutina de Luis Varona
      use kinds
      parameter (maxcar=2)
      integer i,n,j
      real(r8) x1
      real(r8) a(maxcar),v(maxcar,maxcar),cv(maxcar,maxcar),b(maxcar)
      real(r8) u(maxcar),xnor
!      real*8 a(n),v(n,n),cv(n,n),b(n)
!      real*8 u(n),xnor,x1
      call choles(v,n,cv) ! does not work if some diagonals are 0.

      do i=1,n
        call normal(x1,u(i))
!        u(i)=xnor(x1)
      enddo
      do i=1,n
        b(i)=a(i)
        do j=1,i
          b(i)=b(i)+u(j)*cv(j,i)
        enddo
      enddo
      return
      end

!-------------------------------------
       subroutine choles(mat,n,l)
       use kinds
       implicit double precision(a-h,o-z)
                parameter (maxcar=2)
                real(r8) mat(maxcar,maxcar),l(maxcar,maxcar)
!                real*8 mat(n,n),l(n,n)
       do 4 i=1,n
         do 4 j=1,n
4          l(i,j)=0.
       do 1 i=1,n
         l(i,i)=mat(i,i)
         do 2 j=1,i-1
           l(j,i)=mat(j,i)
             do 3 k=1,j-1
3              l(j,i)=l(j,i)-l(k,i)*l(k,j)
             l(j,i)=l(j,i)/l(j,j)
2          l(i,i)=l(i,i)-l(j,i)*l(j,i)
         l(i,i)=l(i,i)**.5
1      continue

       return
       end


